// Simulation of the second order regression model
// -----------------------------------------------
[u,t,n]=file();               // find working directory
chdir(dirname(n(2)));         // set working directory
clear u t n		          // clear auxiliary variables
exec("ScIntro.sce",-1)

// PARAMETERS OF THE SIMULATION
nd=100;                       // length of data
a=[.4 .2];                    // parameters at yt
b=[1 .2 -.5];                 // parameters at ut
k=0;                          // constant (model absolute term)
s=.1;                         // noise variance

yt(1)=1; yt(2)=3;             // initial conditions for output
ut=sin(10*%pi*(1:nd)'/nd)+.001*rand(nd,1,'n'); // input

// TIME LOOP OF THE SIMULATION
th=[a b k]';                  // vector of parameters
for t=3:nd
  // regression vector
  ps=[yt(t-1) yt(t-2) ut(t) ut(t-1) ut(t-2) 1]';
  // regression model
  yt(t)=th'*ps+s*rand(1,1,'norm'); 
end

// RESULTS OF THE SIMULATION
set(gcf(),"position",[700 100 600 500])
subplot(211),plot(1:nd,ut),title('Input')
subplot(212),plot(1:nd,yt),title('Output')
