// np-step prediction with continuous model (known parameters)
// Change: - np = number of steps of prediction
//         - r  = noise variance
//         - th = model parametrs
//         - u  = input signal
[u,t,n]=file();               // find working directory
chdir(dirname(n(2)));         // set working directory
clear u t n		          // clear auxiliary variables
exec("ScIntro.sce",-1),mode(0)

nd=100;                            // number of data
np=5;                              // length of prediction (np>=1)
//  b0 a1 b1  a2 b2 k
th=[1 .4 -.3 -.5 .1 1]';           // regression coefficients
r=.02;                             // noise variance
u=sin(4*%pi*(1:nd)/nd)+rand(1,nd,'norm'); // input
y=ones(1,nd);

nu=zeros(4,2);
yp=ones(1,nd);

// TIME LOOP 
for t=3:(nd-np)                   // time loop (on-line tasks)
  // simulation
  ps=[u(t) y(t-1) u(t-1) y(t-2) u(t-2) 1]';  // regression vector for sim.
  y(t)=ps'*th+sqrt(r)*rand(1,1,'norm');      // output generation

  // prediction
  ps=[u(t+1) y(t) u(t) y(t-1) u(t-1) 1]'; // first reg. vec for prediction
  yy=ps'*th;                      // first prediction at t+1
  for j=2:np                       // loop of predictions for t+2,...,t+np
    tj=t+j;                        // future times for prediction
    ps=[u(tj); yy; ps(1:$-3); 1];  // reg.vecs with predicted outputs
    yy=ps'*th;                     // new prediction (partial)
  end
  yp(t+np)=yy;                     // final prediction for time t+np
end

// Results
s=(np+3):nd;
scf(1);
plot(s,y(s),'.:',s,yp(s),'rx')
set(gca(),"data_bounds",[1 nd -3 5])
legend('output','prediction');
title(string(np)+'-steps ahead prediction')
